#include <windows.h>

#include "GEN.H"
#include "wa_ipc.h"

///
// const messages
///
#define PLUGIN_NAME "MSN Messenger 7.0 Display song Plugin for winamp"
#define PLUGIN_VERSION "v 1.1"
#define PLUGIN_DESC "Đ̋ȖMSN Messengerɕ\vOCł"

///
// DLL Entry point
///
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

///
// Functions
///
void config ();
void quit ();
int init ();


///
// winampGeneralPurposePlugin struct
///
winampGeneralPurposePlugin plugin =
{
	GPPHDR_VER,
	PLUGIN_NAME " " PLUGIN_VERSION,
	init,
	config,
	quit,
};

///
// Send message to messenger
///
HWND msgr = NULL;
COPYDATASTRUCT cds;
void SendMessengerMessage (const char *pStr, bool bKeep=true)
{
	if(pStr == NULL)
	{
		return;
	}
	if(msgr == NULL)
	{
		// find "MsnMsgrUIManager" class
		msgr = FindWindow("MsnMsgrUIManager", NULL);
	}
	if(msgr != NULL)
	{
		// custom message size
		int tsize = strlen(pStr) + 21;

		// create message buffer (sjis)
		char *buf = new char[tsize];
		if(buf == NULL) return;
		ZeroMemory(buf, tsize);

		// copy texts
		strcat(buf, "Winamp\\0Music\\0");
		strcat(buf, bKeep ? "1\\0" : "0\\0");
		strcat(buf, pStr);
		strcat(buf, "\\0");

		// calc wide size
		int len = strlen(buf) * sizeof(wchar_t);
		int size = len + 2;

		// create message buffer (unicode)
		char *wbuf = new char[size];
		if(wbuf == NULL)
		{
			delete [] buf;
			return;
		}
		ZeroMemory(wbuf, size);

		// convert sjis->unicode
		MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, buf, -1, (LPWSTR)wbuf, len);

		// COPYDATASTRUCT struct
		cds.dwData = 1351;	// magic number
		cds.cbData = size;		// data size
		cds.lpData = wbuf;	// reference

		// Send WM_COPYDATA message to MsnMsgrUIManager Class
		if(SendMessage(msgr, WM_COPYDATA, NULL, (WPARAM)&cds))
		{
			msgr = NULL;
		}

		// free
		delete [] wbuf;
		delete [] buf;
	}
}

///
// config
///
void config ()
{
	MessageBox(plugin.hwndParent, PLUGIN_DESC, "Info", MB_OK);
}

///
// quit
///
#define ID_TIMER 4441
void quit ()
{
	KillTimer(plugin.hwndParent, ID_TIMER);

	// end message
	SendMessengerMessage("", false);
}

///
// WndProc
///
#define TITLE_BUF_SIZE 1024

WNDPROC lpWndProcOld;	// old window procedure
bool bStoped = true;
LRESULT CALLBACK WndProc (HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam)
{
	switch(mes)
	{
	case WM_TIMER:
		if( wParam == ID_TIMER )
		{
			if(SendMessage(hWnd, WM_WA_IPC, NULL, IPC_ISPLAYING)==1)
			{
				bStoped = false;

				char *buf = new char[TITLE_BUF_SIZE];
				if(buf == NULL) break;

				// get winamp window title
				GetWindowText(hWnd, buf, TITLE_BUF_SIZE);
				
				// strip " - winamp"
				char *p = strrchr(buf, '-');
				if(p > buf) *(p-1) = '\0';

				// send title
				char *pp = strchr(buf, '.');
				SendMessengerMessage(pp + 2);

				delete [] buf;
			}
			else
			{
				if(!bStoped)
				{
					bStoped = true;
					SendMessengerMessage("", false);
				}
			}
		}
		break;

	default:
		break;
	}

	return CallWindowProc(lpWndProcOld, hWnd, mes, wParam, lParam);
}

///
// init
///
int init ()
{
	lpWndProcOld = (WNDPROC)SetWindowLong(plugin.hwndParent, GWL_WNDPROC, (LONG)WndProc);

	SetTimer(plugin.hwndParent, ID_TIMER, 1000, NULL);

	return 0;
}

///
// winampGeneralPurposePlugin getter
///
extern "C"
{
__declspec( dllexport ) winampGeneralPurposePlugin* winampGetGeneralPurposePlugin ()
{
	return &plugin;
}
}